/*
Copyright (c) 2019-2022 Digital Energy Cloud Solutions LLC. All Rights Reserved.
Authors:
Petr Krutov, <petr.krutov@digitalenergy.online>
Stanislav Solovev, <spsolovev@digitalenergy.online>
Kasim Baybikov, <kmbaybikov@basistech.ru>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
Terraform DECORT provider - manage resources provided by DECORT (Digital Energy Cloud
Orchestration Technology) with Terraform by Hashicorp.

Source code: https://repository.basistech.ru/BASIS/terraform-provider-decort

Please see README.md to learn where to place source code so that it
builds seamlessly.

Documentation: https://repository.basistech.ru/BASIS/terraform-provider-decort/wiki
*/

package account

import (
	"context"

	log "github.com/sirupsen/logrus"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudapi/account"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
)

func utilityAccountComputesListCheckPresence(ctx context.Context, d *schema.ResourceData, m interface{}) (*account.ListComputes, error) {
	c := m.(*controller.ControllerCfg)
	var id uint64

	id = uint64(d.Get("account_id").(int))

	req := account.ListComputesRequest{
		AccountID: id,
	}

	if compute_id, ok := d.GetOk("compute_id"); ok {
		req.ComputeID = uint64(compute_id.(int))
	}

	if name, ok := d.GetOk("name"); ok {
		req.Name = name.(string)
	}

	if rg_name, ok := d.GetOk("rg_name"); ok {
		req.RGName = rg_name.(string)
	}

	if rg_id, ok := d.GetOk("rg_id"); ok {
		req.RGID = uint64(rg_id.(int))
	}

	if tech_status, ok := d.GetOk("tech_status"); ok {
		req.TechStatus = tech_status.(string)
	}

	if ip_address, ok := d.GetOk("ip_address"); ok {
		req.IPAddress = ip_address.(string)
	}

	if extnet_name, ok := d.GetOk("extnet_name"); ok {
		req.ExtNetName = extnet_name.(string)
	}

	if extnet_id, ok := d.GetOk("extnet_id"); ok {
		req.ExtNetID = uint64(extnet_id.(int))
	}

	if sortBy, ok := d.GetOk("sort_by"); ok {
		req.SortBy = sortBy.(string)
	}

	if page, ok := d.GetOk("page"); ok {
		req.Page = uint64(page.(int))
	}

	if size, ok := d.GetOk("size"); ok {
		req.Size = uint64(size.(int))
	}

	log.Debugf("utilityAccountComputesListCheckPresence: load account list")
	accountComputesList, err := c.CloudAPI().Account().ListComputes(ctx, req)
	if err != nil {
		return nil, err
	}

	return accountComputesList, nil
}
